// -------------------------------------------------------------
// 3d code by Georgy Moshkin (Delphi)
// -------------------------------------------------------------
unit vector;

interface

uses Math,dialogs,sysutils;

type TVector=record
              x,y,z:single;  
             end;

type TVectors=array of TVector;

function dot(v1,v2:TVector):single;

function vectorint(v1,v2:TVector;factor:single):TVector;

function vlen(v:TVector):single;

function vcosine(v:TVector):TVector;

function v2minusv1(v2,v1:TVector;factor:single):TVector;

function v1plusv2(v1,v2:TVector;factor:single):TVector;

function normalize(v:TVector):TVector;

function zangle(a,b:single):single;

implementation

function dot(v1,v2:TVector):single;
begin
result:=v1.x*v2.x+v1.y*v2.y+v1.z*v2.z
end;

function vectorint(v1,v2:TVector;factor:single):TVector;
begin
result.x:=v1.x + (v2.x - v1.x) * factor;
result.y:=v1.y + (v2.y - v1.y) * factor;
result.z:=v1.z + (v2.z - v1.z) * factor;
end;

function vlen(v:TVector):single;
begin
result:=sqrt(v.x*v.x+v.y*v.y+v.z*v.z);
end;

function vcosine(v:TVector):TVector;
var l:single;
begin
l:=vlen(v);
result.x:=arccos(v.x/l);
result.y:=arccos(v.y/l);
result.z:=arccos(v.z/l);

end;

function v2minusv1(v2,v1:TVector;factor:single):TVector;
begin
result.x:=(v2.x-v1.x)*factor;
result.y:=(v2.y-v1.y)*factor;
result.z:=(v2.z-v1.z)*factor;
end;

function v1plusv2(v1,v2:TVector;factor:single):TVector;
begin
result.x:=v1.x+v2.x*factor;
result.y:=v1.y+v2.y*factor;
result.z:=v1.z+v2.z*factor;
end;

function normalize(v:TVector):TVector;
var l:single;
begin
result:=v;
l:=sqrt(v.x*v.x+v.y*v.y+v.z*v.z);
if l<>0 then
 begin
  result.x:=result.x/l;
  result.y:=result.y/l;
  result.z:=result.z/l;
 end;
end;

function zangle(a,b:single):single;
var db:single;
var mode:integer;
aa,bb:single;
begin

mode:=0;
aa:=radtodeg(a);
bb:=radtodeg(b);

if bb-aa >= 180 then
        begin
        mode:=1;
        db:=-(360-(bb-aa))
        end
        else if bb-aa <=-180 then
                begin
                mode:=2;
                db:=360+(bb-aa)
                end
                else
                        begin
                        mode:=3;
                        db:= bb-aa;
                        end;


   if abs(db)>90 then
    begin
     db:=0;
//     showmessage('a='+FloatToStr(radtodeg(a))+', b='+FloatToStr(radtodeg(b))+', mode='+IntToStr(mode));
    end;

result:=DegToRad(db);

end;


end.
